﻿#define _CRT_SECURE_NO_WARNINGS
using namespace std;

#include <iostream>
#include <algorithm>

typedef long long ll;

ll f(ll k, ll a, ll x, ll b, ll y) {
	ll ret = 0;
	if (a <= k) ret += (k - a) * x;
	if (a + b <= k) ret += (k - b - a) * y;
	return ret;
}

ll fx(ll x) {
	return x * (x + 1) / 2;
}

void solutionB() {
	int t;
	cin >> t;
	while (t--) {
		ll n, m;
		cin >> n >> m;
		pair<char, int> res = { '#', -1 };
		int id = -1;
		ll sum = fx(n + m);
		ll l = 1, r = n;
		while (r - l > 5) {
			ll m1 = l + (r - l) / 3;
			ll m2 = r - (r - l) / 3;
			if (abs(fx(m1) - (sum - fx(m1))) < abs(fx(m2) - (sum - fx(m2))) ) {
				l = m1;
			}
			else {
				r = m2;
			}
		}
		for (int i = l; i < r; i++) {
			if (abs(fx(i) - (sum - fx(i))) > res.second) {
				res = { 'H', abs(fx(i) - (sum - fx(i))) };
				id = i;
			}
		}
		cout << res.first << ' ' << id << endl;
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	ll k, a, x, b, y;
	cin >> k >> a >> x >> b >> y;

	cout << max(f(k, a, x, b, y), f(k, b, y, a, x));
	return 0;
	solutionB();
}
