﻿#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <random>
#include <string>
#include <numeric>
using namespace std;

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()

int n, m, c;

vector<string> ans;

mt19937 gen;

vector<int> ord = { 0, 1, 2 };

int have[3][11][11];

void solve() {
	if (size(ans) == n) {
		for (auto x : ans) {
			for (int j = 0; j < m; j++) {
				cout << int(x[j]) + 1 << ' ';
			}
			cout << '\n';
		}
		exit(0);
	}
	string cur;
	for (int try_ = 0; try_ < 2 - size(ans) / 5; try_++) {
		cur.clear();
		for (int i = 0; i < m; i++) {
			shuffle(all(ord), gen);
			for (int x : ord) {
				bool fl = 1;
				for (int j = 0; j < i; j++) {
					if (cur[j] == x && have[x][j][i]) {
						fl = 0;
						break;
					}
				}
				if (fl) {
					cur += char(x);
					break;
				}
			}
			if (size(cur) != i + 1) {
				break;
			}
		}
		if (size(cur) == m) {
			for (int i = 0; i < m; i++) {
				for (int j = i + 1; j < m; j++) {
					if (cur[i] == cur[j]) {
						have[cur[i]][i][j]++;
					}
				}
			}
			ans.push_back(cur);
			solve();
			ans.pop_back();
			for (int i = 0; i < m; i++) {
				for (int j = i + 1; j < m; j++) {
					if (cur[i] == cur[j]) {
						have[cur[i]][i][j]--;
					}
				}
			}
		}
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> n >> m >> c;
	if (c == 2) ord.pop_back();
	while (1) {
		solve();
	}
}