﻿#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <random>
#include <assert.h>
#include <string>
#include <time.h>
/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
*/
#include <numeric>
using namespace std;

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()

int n, m, c;

vector<string> ans;

mt19937 gen(time(0));

vector<int> ord = { 0, 1, 2 };

int have[3][11][11];

void solve(int x) {
	if (x == n) {
		for (auto x : ans) {
			for (int j = 0; j < m; j++) {
				cout << int(x[j]) + 1 << ' ';
			}
			cout << '\n';
		}
		exit(0);
	}
	int y = size(ans[x]);
	if (y == m) {
		for (int i = 0; i < m; i++) {
			for (int j = i + 1; j < m; j++) {
				if (ans[x][i] == ans[x][j]) {
					have[ans[x][i]][i][j]++;
				}
			}
		}
		solve(x + 1);
		for (int i = 0; i < m; i++) {
			for (int j = i + 1; j < m; j++) {
				if (ans[x][i] == ans[x][j]) {

					have[ans[x][i]][i][j]--;
				}
			}
		}
		return;
	}

	shuffle(all(ord), gen);
	vector<int> need = ord;
	for (int at : need) {
		if (x == 0) {
			at = y % 3;
		}
		else if (x == 1) {
			at = (y + 1) % 3;
		}
		bool fl = 1;
		for (int j = 0; j < y; j++) {
			if (ans[x][j] == at && have[at][j][y]) {
				fl = 0;
				break;
			}
		}
		if (fl) {
			ans[x] += at;
			solve(x);
			ans[x].pop_back();
			if (x < 3) break;
		}
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> n >> m >> c;
	ans.resize(n);
	if (c == 2) ord.pop_back();
	while (1)
		solve(0);
}