#include <bits/stdc++.h>
/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
*/
#include <numeric>
using namespace std;

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()

void no() {
  cout << 0;
  exit(0);
}

ll mod = 1e9 + 7;

ll pw(ll n, ll k) {
  ll ret = 1;
  while (k) {
    if (k & 1) ret = ret * n % mod;
    n = n * n % mod;
    k >>= 1;
  }
  return ret;
}

const ll N = 2e5 + 1;
ll fact[N], rfact[N];

ll cnt[2][2];

ll cnk(ll n, ll k) {
  if (k < 0) return 0;
  if (k == 0) return 1;
  if (k == n) return 1;
  if (k > n) return 0;
  return (fact[n] * rfact[k] % mod) * rfact[n - k] % mod;
}

ll stars(ll n, ll k) {
  if (n == 0) return 1;
  ll ret = 0;
  for(int cntZero = 0; cntZero < k; cntZero++) {
    ret += cnk(k, cntZero) * cnk(n - 1, k - cntZero - 1);
    //cout << cnk(k, cntZero) << ' ' << cnk(n - 1, k - cntZero - 1) << endl;
    ret %= mod;
  }
  return ret;
}

ll kek(ll a, ll b, ll c, ll d) {
  if (a < 0) return 0;
  if (b < 0) return 0;
  ll ans = 1;
  ans = ans * stars(b, a + 1) % mod;
  ans = ans * stars(d, b) % mod;
  ans = ans * fact[a] % mod;
  ans = ans * fact[b] % mod;
  ans = ans * fact[c] % mod;
  ans = ans % fact[d] % mod;
  return ans;
}

ll bad[2][2];

ll solve(string a, string b, string c) {
  cnt[0][0] = cnt[0][1] = cnt[1][0] = cnt[1][1] = 0;
  bad[0][0] = bad[0][1] = 0;
 // for(char &c : a) c -= '0';
 // for(char &c : b) c -= '0';
 // for(char &d : c) d -= '0';
  for(int i = 0; i < size(a); i++) {
    bool fl = (a[i] == 0 || b[i] == 0 || c[i] == 0);
    if ((a[i] + b[i]) % 10 == c[i]) {
      cnt[(a[i] + b[i]) / 10][0]++;
      bad[(a[i] + b[i]) / 10][0]++;
    } else if ((a[i] + b[i] + 1) % 10 == c[i]) {
      cnt[(a[i] + b[i] + 1) / 10][1]++;
      bad[(a[i] + b[i] + 1) / 10][1]++;
    } else {
      return 0;
    }
  }
  if (cnt[0][1] != cnt[1][0]) return 0;
  if (cnt[0][0] + cnt[0][1] == 0) return 0;
  if (!cnt[0][1] && (cnt[1][0] + cnt[1][1])) return 0;
  ll full = kek(cnt[0][0], cnt[0][1], cnt[1][0], cnt[2][2]);
  ll startZero = kek(cnt[0][0] - 1, cnt[0][1], cnt[1][0], cnt[2][2]);
  ll startOne = (full - startZero + mod * mod) % mod;
  ll trueAns = startOne + startZero;
  return full;
}

ll stupid(string a, string b, string c) {
  vector<int> ord(size(a));
  iota(all(ord), 0);
  ll ans = 0;
  set<vector<pair<int, int>>> s;
  do {
    bool fl = 1;
    int bal = 0;
    for(int x : ord) {
      int sum = a[x] + b[x] + bal;
      if (x == ord.back() && (!a[x] || !b[x] || !c[x])) fl = 0;
      if (c[x] != sum % 10) {
        fl = 0;
        break;
      }
      bal = sum / 10;
    }
    if (fl && bal == 0) {
      vector<pair<int, int>> kek;
      reverse(all(ord));
      for(int j : ord) {
        ll su = a[j] + b[j];
        if (su % 10 != c[j]) su++;
        kek.emplace_back(su / 10, su - a[j] - b[j]);
      }
      reverse(all(ord));
      s.insert(kek);
      ans++;
    }
  } while (next_permutation(all(ord)));
  return ans;
}

void precal() {
  fact[0] = 1;
  for(int i = 1; i < N; i++) {
    fact[i] = fact[i - 1] * i % mod;
  }
  for(int i = 0; i < N; i++) {
    rfact[i] = pw(fact[i], mod - 2);
  }
}

void hd() {
  string a, b, c;
  cin >> a >> b >> c;
  for(char &c : a) c -= '0';
  for(char &c : b) c -= '0';
  for(char &d : c) d -= '0';
  cout << solve(a, b, c);
  if (size(a) < 12) {
    cerr << stupid(a, b, c) << endl;
  }
  exit(0);
}

int main()
{
  precal();
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
  hd();
#endif
  hd();
  int n;
  mt19937 gen;
  for(int tt = 0; tt < 1e6; tt++) {
    if (tt % 10000 == 0) cerr << tt << endl;
    n = 5;
    string a, b, c;
    ll tmp = 0;
    for(int j = 0; j < n; j++) {
      a += char(gen() % 9 + 1);
      b += char(gen() % 9 + 1);
      c += char(gen() % 9 + 1);
    }
    if (solve(a, b, c) != stupid(a, b, c)) {
      cout << solve(a, b, c) << ' ' << stupid(a, b, c) << endl;
      for(char d : a) cout << char('0' + d); cout << endl;
      for(char d : b) cout << char('0' + d); cout << endl;
      for(char d : c) cout << char('0' + d); cout << endl;
      return 0;
    }
  }
}
