﻿#define _CRT_SECURE_NO_WARNINGS
using namespace std;

#include <iostream>
#include <algorithm>

typedef long long ll;

ll fx(ll x) {
	return x * (x + 1) / 2;
}

void solutionB() {
	int t;
	cin >> t;
	while (t--) {
		ll n, m;
		cin >> n >> m;
		pair<char, ll> res = { 'V',  1e18};
		int id = 0;
		ll sum = fx(n * m);
		ll l = 1, r = n;
		while (r - l > 1) {
			ll mid = (l + r) / 2;
			if (abs(fx(mid * m) - (sum - fx(mid * m))) * 2 <= sum) {
				l = mid;
			}
			else {
				r = mid;
			}
		}
		for (int i = l; i < min(n, l + 5); i++) {
			if (abs(fx(i * m) - (sum - fx(i * m))) < res.second) {
				res = { 'H', abs(fx(i * m) - (sum - fx(i * m))) };
				id = i;
			}
			//cout << "H " << i << ' ' << abs(fx(i * m) - (sum - fx(i * m))) << endl;
		}
		l = 1, r = m;
		auto f = [&](ll v) {
			ll su1 = fx(v) * n + fx(n - 1) * m * v;
			return abs(su1 - (sum - su1));
		};
		while (r - l > 30) {
			ll m1 = l + (r - l) / 3;
			ll m2 = r - (r - l) / 3;
			if (f(m1) > f(m2)) {
				l = m1;
			}
			else {
				r = m2;
			}
		}
		for (int i = l; i < r; i++) {
			if (f(i) < res.second) {
				res = { 'V', f(i) };
				id = i;
			}

		//cout << "V " << i << ' ' <<f(i) << endl;
		}

		cout << res.first << ' ' << id + 1 << endl;
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solutionB();
}
