﻿#define _CRT_SECURE_NO_WARNINGS
using namespace std;

#include <iostream>
#include <vector>
#include <map>
#include <assert.h>
#include <random>
#include <numeric>
#include <unordered_map>
#include <time.h>
#include <algorithm>

#pragma GCC optimize("Ofast", "unroll-loops")

typedef long long ll;

#define size(x) (int)x.size()
#define all(x) (x).begin(), (x).end()

vector<pair<int, int>> a;
const int N = 1e5 + 1;
vector<int> g[N];
int used[N];
int pa[N];

unordered_map<int, vector<pair<int, int>>> kek;
void solve(int step) {
	int n = size(a);
	if (kek.empty())
		for (int i = 0; i < n; i++) {
			kek[a[i].first].emplace_back(step - a[i].second, i);
		}
	vector<int> ord(n);
	iota(all(ord), 0);
	mt19937 gen;
	shuffle(all(ord), gen);
	unordered_map<int, int> pt;
	int timer = 1;
	for(int y : ord) {
		pt.clear();
		timer++;
		int x = a[y].first;
		vector<int> ans = { y };
		int cur = a[y].first;
		while (size(ans) < n) {
			if (pt[cur] < size(kek[cur])) {
				if (ans.back() != kek[cur][pt[cur]].second)
					ans.push_back(kek[cur][pt[cur]].second);
				cur = kek[cur][pt[cur]++].first;
		
			}
			else break;
		}
		if (size(ans) == n) {
			cout << "Yes\n";
			for (int x : ans) cout << x + 1 << ' ';
			exit(0);
		}
	}
}

unordered_map<int, int> cntStart;

vector<int> order;

unordered_map<int, int> was;

inline void quickCheck(int step) {
	if (was.find(step) != was.end()) return;
	was[step] = 1;
	int can = 0;

	unordered_map<int, int> cur;
	for (int i : order) {
		if (cntStart.find(step - a[i].second) == cntStart.end()) {
			if (!can) can = 1;
			else return;
		}
	}
	auto tmp = a;
	solve(step);
	a = tmp;
}

double startTime = clock();

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	int n;
	cin >> n;

	order.resize(n);
	iota(all(order), 0);
	mt19937 gen(228);
	shuffle(all(order), gen);
	int step = -1;
	for (int i = 0; i < n; i++) {
		int m, s;
		cin >> m >> s;
		int first, last;
		for (int j = 0; j < m; j++) {
			int p;
			cin >> p;
			if (j == 0) first = p;
			if (j > 0) {
				if (step == -1) {
					step = p - last;
				}
				else if (p - last != step) {
					cout << "No\n";
					return 0;
				}
			}
			last = p;
		}
		a.emplace_back(first, s - last);
	}
	if (step != -1) {
		solve(step);
		cout << "No\n";
		return 0;
	}
	if (n == 1) {
		cout << "Yes\n1";
		return 0;
	}
	for (int i = 0; i < n; i++) {
		cntStart[a[i].first]++;
	}
	int x = gen() % n, y = gen() % n;
	while (x == y) {
		x = gen() % n;
	}
	int pt = 0;
	while (pt < size(order)) {
		if (order[pt] != x) {
			quickCheck(a[x].second + a[order[pt]].first);
		}
		if (order[pt] != y) {
			quickCheck(a[y].second + a[order[pt]].first);
		}
		pt++;
	}
	cout << "No\n";
	
}