﻿#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <random>
#include <assert.h>
#include <string>
#include <numeric>
using namespace std;

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()

int n, m, c;

vector<string> ans;

mt19937 gen;

vector<int> ord = { 0, 1, 2 };

int have[3][11][11];

void solve(int x, int y) {
	if (x == n) {
		for (auto x : ans) {
			for (int j = 0; j < m; j++) {
				cout << int(x[j]) + 1 << ' ';
			}
			cout << '\n';
		}
		exit(0);
	}
	if (y == m) {
		for (int i = 0; i < m; i++) {
			for (int j = i + 1; j < m; j++) {
				if (ans[x][i] == ans[x][j]) {
					assert(have[ans[x][i]][i][j] == 0);
					have[ans[x][i]][i][j]++;
				}
			}
		}
		solve(x + 1, 0);
		for (int i = 0; i < m; i++) {
			for (int j = i + 1; j < m; j++) {
				if (ans[x][i] == ans[x][j]) {

					assert(have[ans[x][i]][i][j] == 1);
					have[ans[x][i]][i][j]--;
				}
			}
		}
		return;
	}
	for (int at : {1, 0}) {
		bool fl = 1;
		for (int j = 0; j < y; j++) {
			if (ans[x][j] == at && have[at][j][y]) {
				fl = 0;
				break;
			}
		}
		if (fl) {
			ans[x] += at;
			solve(x, y + 1);
			ans[x].pop_back();
		}
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> n >> m >> c;
	ans.resize(n);
	for (int i = 0; i < 3; i++) {
		for (int j = 0; j < 10; j++) {
			for (int k = 0; k < 10; k++) {
				have[i][j][k] = 0;
			}
		}
	}
	if (c == 2) ord.pop_back();
	solve(0, 0);
}